#include <fmt/format.h>
#include <iostream>
#include <cstdio>

/// floating point : fixed

namespace
{
    const double pi{3.14159265359};
    const double po{30.14159265359};
} // namespace

int main()
{
    /// no precision specified
    std::printf("%f \n", pi);
    std::cout << std::fixed << pi << std::defaultfloat <<std::endl;
    std::cout << fmt::format("{:f} \n", pi);

    std::printf("%f \n", po);
    std::cout << std::fixed << po << std::defaultfloat <<std::endl;
    std::cout << fmt::format("{:f} \n", po);

    /// precision : the total number of digits after the decimal point
    std::printf("%.3f \n", pi);

    auto precision = std::cout.precision(3);
    std::cout << std::fixed << pi << std::defaultfloat <<std::endl;
    std::cout.precision(precision);

    std::cout << fmt::format("{:.3f} \n", pi);

    std::printf("%.3f \n", po);

    precision = std::cout.precision(3);
    std::cout << std::fixed << po << std::defaultfloat <<std::endl;
    std::cout.precision(precision);

    std::cout << fmt::format("{:.3f} \n", po);

    return 0;
}
