#include <fmt/format.h>
#include <iostream>
#include <string>
#include <vector>

/// let's add support for a a custom type : say a vector<T>
///  ==> write out all vector elements, comma seperated and use the format string specified on every element

/// struct formatter needed
///         parse()             : stores the parsed format specifier in *this, and return an interator passed the end of the parsed range
///         format)

///                         format_parse_context
///                         format_context


/// let's first do some inspection on the parse thing, and provide a fixed value for the vector formatting

///             note does not work for {}  --> there must be something in, eg {:}

template<typename T>
struct fmt::formatter<std::vector<T>>
{
    auto /*constexpr*/ parse(fmt::format_parse_context& ctx)
    {
        std::string parseContext{std::begin(ctx), std::end(ctx)};

        std::cout << "parse : " << parseContext << std::endl;

        return std::end(ctx) - 1;           /// -1 needed : shouldn't we considere the } also as parsed ? ==> without -1 fmt throws : unknown format specifier
    }

    auto format(const std::vector<T>& vec, fmt::format_context& ctx)
    {
        return fmt::format_to(ctx.out(), "vec size is {}", vec.size());
    }

};

int main()
{
    std::vector<int> myVec{1, 2, 242, 10000, 6547892};

    std::cout << fmt::format("The vector: {:}", myVec) << std::endl;            /// }
    std::cout << fmt::format("The vector: {:03}", myVec) << std::endl;          /// 03}

    return 0;
}
