#include <fmt/format.h>
#include <iostream>
#include <string>
#include <vector>

/// let's add support for a a custom type : say a vector<T>
///  ==> write out all vector elements, comma seperated and use the format string specified on every element

/// struct formatter needed
///         parse()             : stores the parsed format specifier in *this, and return an interator passed the end of the parsed range
///         format)             :   formats according to the specifieres stoed in *this, writes the output to the formattingContext.out() and returns an iterator past the end of the output range

///                         format_parse_context
///                         format_context


///             note does not work for {}  --> there must be something in, eg {:}

template<typename T>
struct fmt::formatter<std::vector<T>>
{
    std::string formatString;       /// let's store here the format string that was used

    auto /*constexpr*/ parse(fmt::format_parse_context& ctx)
    {
        std::string parseContext{std::begin(ctx), std::end(ctx)};

        formatString = "{:" + parseContext;  /// let's put the {: back so we can have a nice format string to apply to each element

        return std::end(ctx) - 1;
    }

    auto format(const std::vector<T>& vec, fmt::format_context& ctx)
    {
        auto out = ctx.out();
        fmt::format_to(out, "[");
        if(vec.size() > 0)
        {
            fmt::format_to(out, formatString, vec[0]);
        }
        for(auto idx = 1U; idx < vec.size(); ++idx)
        {
            fmt::format_to(out, ", " + formatString, vec[idx]);
        }

        fmt::format_to(out, "]");
        return fmt::format_to(out, "\n");
    }
};

int main()
{
    std::vector<int> myVec{1, 2, 242, 10000, 6547892};

    std::cout << fmt::format("The vector: {:}", myVec) << std::endl;
    std::cout << fmt::format("The vector: {:03}", myVec) << std::endl;
    std::cout << fmt::format("The vector: {:#X}", myVec) << std::endl;

    return 0;
}
