#include <fmt/format.h>
#include <iostream>
#include <string>

///             note does not work for {}  --> there must be something in, eg {:}

struct Coordinate
{
    int x;
    int y;
};

template<>
struct fmt::formatter<Coordinate>
{
    std::string formatString;       /// let's store here the format string that was used

    auto /*constexpr*/ parse(fmt::format_parse_context& ctx)
    {
        const std::string parseContext{std::begin(ctx), std::end(ctx)};

        formatString = "{:" + parseContext;  /// let's put the {: back so we can have a nice format string to apply to each element

        return std::end(ctx) - 1;
    }

    auto format(const Coordinate& coordinate, fmt::format_context& ctx)
    {
        auto out = ctx.out();
        fmt::format_to(out, "(");
        fmt::format_to(out, formatString, coordinate.x);
        fmt::format_to(out, ", ");
        fmt::format_to(out, formatString, coordinate.y);
        return fmt::format_to(out, ")\n");
    }
};

int main()
{
    Coordinate co1{242, 51};

    std::cout << fmt::format("Coordinate: {:}", co1) << std::endl;
    std::cout << fmt::format("Coordinate: {:010}", co1) << std::endl;
    std::cout << fmt::format("Coordinate: {:x}", co1) << std::endl;

    return 0;
}
