#include <fmt/format.h>
#include <iostream>
#include <limits>

///   SIGN option

/// + : sign to be used for BOTH positive and negative numbers
/// - : sign to be used only for negative numbers  (default behavior)
/// space : leading space for positive numbers and minus sign for negative numbers

int main()
{

    std::cout << fmt::format("{} {:+} {:-} {: }", 1, 1, 1, 1) << std::endl;

    std::cout << fmt::format("{} {:+} {:-} {: }", -1, -1, -1, -1) << std::endl;

    std::cout << fmt::format("{} {:+} {:-} {: }", 0, 0, 0, 0) << std::endl;


    const auto inf{std::numeric_limits<double>::infinity()};
    const auto nan{std::numeric_limits<double>::quiet_NaN()};

    std::cout << fmt::format("{} {:+} {:-} {: }", nan, nan, nan, nan) << std::endl;
    std::cout << fmt::format("{} {:+} {:-} {: }", inf, inf, inf, inf) << std::endl;

    return 0;
}
