#include <fmt/format.h>
#include <iostream>
#include <cstdio>

/// floating point : default

namespace
{
    const double pi{3.14159265359};
    const double po{30.14159265359};
} // namespace

int main()
{
    /// no precision specified
    std::printf("%f \n", pi);           /// %f : decimal floating point
    std::cout << pi << std::endl;
    std::cout << fmt::format("{} \n", pi);

    std::printf("%f \n", po);
    std::cout << po << std::endl;
    std::cout << fmt::format("{} \n", po);

    /// precision : the total number of digits (except printf, still number of digits after the decimal point !!!)
    std::printf("%.3f \n", pi);

    auto precision = std::cout.precision(3);
    std::cout << pi << std::endl;
    std::cout.precision(precision);

    std::cout << fmt::format("{:.3} \n", pi);

    std::printf("%.3f \n", po);

    precision = std::cout.precision(3);
    std::cout << po << std::endl;
    std::cout.precision(precision);

    std::cout << fmt::format("{:.3} \n", po);

    return 0;
}
