#include <fmt/format.h>
#include <iostream>
#include <cstdio>

/// floating point : scientific

namespace
{
    const double pi{3.14159265359};
    const double po{30.14159265359};
} // namespace

int main()
{
    /// no precision specified
    std::printf("%e \n", pi);           /// %e : scientific lowercase
    std::cout << std::scientific << pi << std::defaultfloat <<std::endl;
    std::cout << fmt::format("{:e} \n", pi);

    std::printf("%e \n", po);
    std::cout << std::scientific << po << std::defaultfloat <<std::endl;
    std::cout << fmt::format("{:E} \n", po);        /// upper case E

    /// precision : the total number of digits after the decimal point
    std::printf("%.3e \n", pi);
    auto precision = std::cout.precision(3);

    std::cout << std::scientific << pi << std::defaultfloat <<std::endl;
    std::cout.precision(precision);

    std::cout << fmt::format("{:.3e} \n", pi);

    std::printf("%.3e \n", po);

    precision = std::cout.precision(3);
    std::cout << std::scientific << po << std::defaultfloat <<std::endl;
    std::cout.precision(precision);

    std::cout << fmt::format("{:.3e} \n", po);

    return 0;
}
